"use strict";
var page = require('webpage').create();
var server = require('webserver').create();
var system = require('system');
var port;
var pageError;
var DEFAULT = {
  ERROR_CODE: 500,
  VALID_CODE: 200
};

page.onResourceError = function (resourceError) {
  console.log('onResourceError');
  console.log(JSON.stringify(resourceError));
  pageError = resourceError;
};

port = 9998;
var listening = server.listen(port, function (request, response) {
  console.log("GOT HTTP REQUEST FROM PHANTOM");
  console.log(JSON.stringify(request, null, 4));

  response.headers = {"Cache": "no-cache", "Content-Type": "text/html"};

  if (request.method === 'POST') {
    pageError = null;
    if (request.post.overrideDefault) {
      evaluate(request.post['eval'], request.post['options'], function (err, result) {
        if (err) {
          request.statusCode = DEFAULT.ERROR_CODE;
          request.write(JSON.stringify(err));
          return request.close();
        }
        request.statusCode = DEFAULT.VALID_CODE;
        request.write(result);
        request.close();
      });
    }

    page.open(request.post.link, function (status) {
      if (status === 'fail' || pageError) {
        response.statusCode = pageError.status || DEFAULT.ERROR_CODE;
        response.write(JSON.stringify(pageError.errorString));
        response.close();
        return;
      }

      evaluate(request.post['eval'], request.post['options'], function (err, result) {
        if (err) {
          response.statusCode = DEFAULT.ERROR_CODE;
          response.write(JSON.stringify(err));
          return response.close();
        }
        response.statusCode = DEFAULT.VALID_CODE;
        response.write(result);
        response.close();
      });
    });
  } else {
    response.statusCode = DEFAULT.VALID_CODE;
    response.write('OK');
    response.close();
  }
});


function evaluate(code, options, done) {
  try {
    eval(code);
  }
  catch (err) {
    done(err);
  }
}

if (!listening) {
  console.log("could not create web server listening on port " + port);
  server.close();
}