'use strict';

const deepFreeze = require('deep-freeze-strict');

const STRATEGY = require('./constants').STRATEGY;
const HTTP_SCRAPER = require('./http/');
const CASPER_SCRAPER = require('./casperjs/');
const PHANTOM_SCRAPER = require('./phantomjs/');
const NIGHTMARE_SCRAPER = require('./nightmarejs/');

module.exports = deepFreeze({
  [STRATEGY.HTTP]:  HTTP_SCRAPER,
  [STRATEGY.CASPERJS]:  CASPER_SCRAPER,
  [STRATEGY.PHANTOMJS]:  PHANTOM_SCRAPER,
  [STRATEGY.NIGHTMAREJS]:  NIGHTMARE_SCRAPER,
});